﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buzz.MachineInterface;

namespace Jeskola.Gain
{
	[MachineDecl(Name = "ManagedMachine", ShortName = "Managed", Author = "fgsd")]
	public class ManagedMachine : IBuzzMachine
	{
		IBuzzMachineHost host;

		public ManagedMachine(IBuzzMachineHost host)
		{
			this.host = host; 
			Gain = new Interpolator();
		}

		[ParameterDecl(ResponseTime = 5, MaxValue = 127, DefValue = 80, Transformation = Transformations.Cubic, TransformUnityValue = 80, ValueDescriptor = Descriptors.Decibel)]
		public Interpolator Gain { get; private set; }

		[ParameterDecl(ValueDescriptions = new[] { "no", "yes" })]
		public bool Bypass { get; set; }

		public Sample Work(Sample s) 
		{
			return Bypass ? s : s * Gain.Tick();
		}
	}

}
